###############################################################################
## Botnet control 2.2.4
## KobazBotNet.tcl 
## First Public Release
## 
## AUTHOR: Kobaz Mi'Daire <krobaz@yahoo.com>
## 
## REQUIRES: Eggdrop 1.3.x AND tcl 8.1
##           KobazConfig.tcl
##
## FEATURES: Provides a way to execute tcl command on every bot on a botnet
##           (Read instuctions below)
## 
## COMMANDS: Arguments in "< >" are mandatory.
##           Arguments in "? ?" are optional.  
##           Arguments in "[ ]" are a toggle, and mandatory.
##           Arguments in "( )" must be used together
## 
## DCC:
## .allbots <tcl command>
##   example: .allbots putlog "hi there"
###############################################################################

source scripts/kobazscripts/KobazDep.tcl
kbrequiretcl 8.1

namespace eval KobazBotNet {

# This script, like getops, needs to be run on every bot you wish
#  to be affected, to work.
# BEFORE RUNNING SCRIPT, FOR YOU OWN SAFTEY REASONS:
# EDIT NETNAME AND SECRET
# if you have groups of bots on a botnet that you want seperated
# then make sure netname is unique for each group
# example: group one: netname would be "bots1"
#          group two: netname would be "bots2"
# netname can be anything
#
# secret is the password for exchanging command info through the botnet
# this is so that if someone guesses your netname they cannot make your bots
# preform commands
#
# This command is bound to to +n by default, because any tcl command can be
# executed, such as exec, giving basicly full remote access to your account.

kbrequire Config

namespace import -force ::KobazTools::*
namespace import -force ::KobazConfig::*

if {![info exists firstload]} {
    set firstload      "1"
}

set_config KobazBotNet secret  "thekobaznetpassword"
set_config KobazBotNet netname "Kobaz"
set_config KobazBotNet debug   "0"

bind bot - allbots      KobazBotNet::bot_allbots
bind bot - allbots_resp KobazBotNet::bot_allbots_resp
bind dcc n allbots      KobazBotNet::dcc_allbots

##########################################################################
# Dont bother editing anything below this unless you really really want to
##########################################################################

proc error {args} {
    putlog "KBOTNET=:=ERROR $args"
}

proc debug {args} {
    set debug [get_config KobazBotNet debug]
    if {$debug == "1"} {
	putlog "KBOTNET:DEBUG $args"
    }
}

proc dcc_allbots {handle idx arg} {
    global botnick
    if {$arg == ""} {
	putdcc $idx "Usage: .allbots <command>"
	return
    }
    putlog "#$handle# allbots $arg"
    set netname [get_config KobazBotNet netname]
    set secret  [get_config KobazBotNet secret]
    set command [encrypt $secret $arg]

    putallbots "allbots $netname $command"
    catch {eval $arg} error
    putlog "ALLBOTS: From $botnick: $error"
    return
}

proc bot_allbots {bot com arg} {
    set netname [get_config KobazBotNet netname]
    set secret [get_config KobazBotNet secret]
    set netname_chal [lindex $arg 0]

    if {$netname != $netname_chal} {return}

    set arg [lrange $arg 1 end]
    set command [decrypt $secret $arg]
    putlog "ALLBOTS: $bot submitted command: $command"

    catch {eval $command} error
    putbot $bot "allbots_resp $netname $error"
    return
}

proc bot_allbots_resp {bot com arg} {
    set netname [get_config KobazBotNet netname]
    set netname_chal [lindex $arg 0]
    set secret [get_config KobazBotNet secret]

    if {$netname != $netname_chal} {return}
    set msg [lrange $arg 1 end]
    putlog "ALLBOTS: From $bot: $msg"
    return
}

putlog "KobazBotNet.tcl by Kobaz loaded."
}



